#include <qapp.h>
#include <qstring.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>
#include "mixer.h"

int dev=0;
int source,id;
int finput;

Mixer::Mixer(char *rawdev)
{
    if ((mixfd = open(rawdev, O_RDWR, 0)) < 0) {
	perror("kLo_mix - error on open_mixer");
	exit(1);
    }
}

void Mixer::write_vol(Volume V)
{
    int v;
    v = (V.getleft() << 8) + V.getright();
    if (ioctl(mixfd, MIXER_WRITE(dev), &v) < 0) {
	perror("kLo_mix - error on write_vol");
	printf("          mixer channel: %d\n",dev);
	fflush(stdout); 
    }
}

Volume Mixer::read_vol()
{
    int v;
    if (ioctl(mixfd, MIXER_READ(dev), &v) < 0) {
	perror("kLo_mix - error on read_vol");
	printf("          mixer channel: %d\n",dev);
	fflush(stdout); 
    }
    Volume V((unsigned char) ((v & 0xff00) >> 8),(unsigned char) (v & 0x00ff));
    return V;
}

void Mixer::write_input_1()
{
id = SOUND_MIXER_LINE;
source = 1 << id;
 if (ioctl(mixfd,SOUND_MIXER_WRITE_RECSRC,&source) == -1) {
    perror("kLo_mix - error setting mixer recording source to LINE_IN");
    fflush(stdout); 
    }
}

void Mixer::write_input_2()
{
id = SOUND_MIXER_MIC;
 source = 1 << id;
 if (ioctl(mixfd,SOUND_MIXER_WRITE_RECSRC,&source) == -1) {
    perror("kLo_mix - error setting mixer recording source to MIC");
    fflush(stdout); 
    }
}

void Mixer::write_input_3()
{
id = SOUND_MIXER_CD;
 source = 1 << id;
 if (ioctl(mixfd,SOUND_MIXER_WRITE_RECSRC,&source) == -1) {
    perror("kLo_mix - error setting mixer recording source to CD");
    fflush(stdout); 
    }
}

void Mixer::read_input()
{
  if (ioctl(mixfd,SOUND_MIXER_READ_RECSRC,&source) == -1) {
    perror("kLo_mix - error reading mixer recording source");
    printf("          i try to set MIC ...\n");
    }
  id = 0;
  if (source == 0)
    {
      id = SOUND_MIXER_MIC;
      source = 1 << id;
      if (ioctl(mixfd,SOUND_MIXER_WRITE_RECSRC,&source) == -1)
        perror("kLo_mix - error setting mixer recording source to MIC!");
    }
  else
    {
      while ((source & 1) == 0)
        {
          source = source>>1;
          ++id;
        }
    }
//  printf("Current recording source ID=%d\n",id);
  switch (id)
    {
    case SOUND_MIXER_LINE:
	finput=1;
      break;
    case SOUND_MIXER_MIC:
	finput=2;
      break;
    case SOUND_MIXER_CD:
	finput=3;
      break;
    default:
      printf("kLo_mix - invalid recording source!\n");
    }
}

